// Turns an image into an ID badge with a number and a barcode, and saves the data to a .csv file that can be opened with a database program.

var pl = new ActiveXObject("PhotoLine.Application");
function loadLibrary(file) { var fso = new ActiveXObject("Scripting.FileSystemObject"), p; with (fso) { p = GetAbsolutePathName("."); p = BuildPath(p, "lib"); p = BuildPath(p, file); } var f = fso.OpenTextFile(p, 1); eval(f.ReadAll()); f.Close(); } loadLibrary("js_constants.js"); loadLibrary("js_library.js");



// settings:
var dFile = fsoBuildPath(getDesktop(), "database.csv");
var badgeWidth = 900;
var badgeHeight = 1500;
var resolution = 300;
var imageMax = 700;
var imageTop = 200;
//var increment = 1;
var increment = Math.floor(Math.random() * 1000) + 1000;



var doc, docSize, docRes, scale, bg, dArray, name, flag, entry, code, ww, hh, xx, yy, fontSize;

doc = pl.ActiveDocument;
if (doc == null)
  alert("Please open a badge image.");
else { //



doc.Merge();
docSize = VBArray(doc.Size).toArray();
scale = imageMax / Math.max(docSize[0], docSize[1]);

doc.DoOperation("Scale", "Mode", SMNormal, "ValueX", docSize[0]*scale, "ValueY", docSize[1]*scale,
  "Interpolation", IMMitchellNetravali);

docSize = VBArray(doc.Size).toArray();
docRes = resolution;
doc.Resolution = docRes;

bg = doc.RootLayer.First;
bg.Copy();
doc.Paste();
bg.Next.Name = "Portrait";

drawPolygon([0, 0, docSize[0], docSize[1]], hexColor(White), true, true);

doc.DoOperation("Resize", "Size", [badgeWidth, badgeHeight], "Position", [(badgeWidth-docSize[0])/2, imageTop],
  "Color", hexColor(White));

var Base64Str = "UGhvdG8gTGluZSBBY3Rpb25zAAAAAQAAAAABAP+bAAAAE0xheWVyRWZmZWN0c0FjdGlvbgABAAAA" +
  "AAAAAAASAgEAAAABAAAABAAAAAH/////AAAAAQAAALIAAQABAAAAAAAAAKIAAAABAP+bAAAAFFNo" +
  "YWRvdzJET3V0ZXJFZmZlY3QAAQEAAAAAAAAATwEBAAAAAgAAAEEBAAAAAAAAAAApAAEABQAAAAYA" +
  "AAAZAQAAAAAAAAAAAAAAAAAAAAAAACAAAAAAAf////8AAAACAAAAAgCZ//////////8AAAAEAAAA" +
  "FCZmZoD//yv7eAAAAz1wogD//AABAAAABQAAAAIAAP///////////////w=="; // shadow outside

doc.ActiveLayer = doc.RootLayer.Last;
doc.DoOperation("Action", "Data", Base64Str);
doc.ActiveLayer = doc.RootLayer.First;

docSize = VBArray(doc.Size).toArray();



  // CHOOSE A NAME



dArray = readTextFile(dFile).replace(/(?:^\s*)|(?:\s*$)/g, ""); // leading and trailing spaces;
if (dArray == "")
  dArray = [];
else
  dArray = dArray.replace(/\r?\n/g, "\n").split("\n");



do {

  name = pl.InputBox("", "Name:");
  flag = 0;

  if (name.replace(/\s/g, "") == "")
    flag = 1;
  else if (name.search(",") > -1) {
    alert("Name may not contain commas.");
    flag = 2; }
  else {
    name = name.replace(/(?:^\s*)|(?:\s*$)/g, ""); // leading and trailing spaces
    for (var i=0; i<dArray.length; i++) {
      entry = dArray[i].split(",");
      if (entry[0].toLowerCase() == name.toLowerCase()) {
        alert("Name is already in use.");
        flag = 2;
        break;
      }
    }
  }

}

while (flag == 2);

if (flag == 0) { // name o.k.



  // GENERATE THE CODE NUMBER

if (dArray.length == 0)
  code = (Math.floor(Math.random()*100000000000) + 100000000001).toString().replace(/(.{4})(?=.)/g, "$1 ");
else {
  entry = dArray[dArray.length-1].split(",");
  code = (parseInt(entry[1].replace(/\s/g, "")) + increment).toString().replace(/(.{4})(?=.)/g, "$1 ");
} // not to exceed 9007199254740991



  // WRITE TO THE DATABASE

if (dArray.length == 0)
  appendTextFile(dFile, "Name,Number,Image");
appendTextFile(dFile, name + "," + code + "," + getDocName(doc.Path));



  // BARCODE LAYER

ww = 2.75*docRes;
hh = 0.5*docRes;
xx = docSize[0]/2 - ww/2;
yy = docSize[1] - hh - 0.125*docRes;

doc.DoOperation("Barcode", "Font", "Courier New", "Position", [xx, yy, ww, hh],
  "ShowText", false, "Type", BarcodeC128, "Value", code);



  // NAME AND CODE NUMBER TEXT

fontSize = 72;

xx = 0.125*docRes;
yy = yy - fontSize*3;
ww = docSize[0];
hh = fontSize*2.5;

createTextLayer(name + "\r\n" + code, "Palatino Linotype", fontSize, hexColor(Black), xx, yy, ww, hh, PALeft, true);



} // name o.k.



doc.ActiveLayer = doc.RootLayer.First;



} //
