// PhotoLine script by Russell Cottrell.
// Adds faux matting and a title to an image.
// Optimized for the screen.

var pl = new ActiveXObject("PhotoLine.Application");
function loadLibrary(file) { var fso = new ActiveXObject("Scripting.FileSystemObject"), p; with (fso) { p = GetAbsolutePathName("."); p = BuildPath(p, "lib"); p = BuildPath(p, file); } var f = fso.OpenTextFile(p, 1); eval(f.ReadAll()); f.Close(); } loadLibrary("js_constants.js"); loadLibrary("js_library.js");

var doc = pl.ActiveDocument;
if (doc == null)
  alert("Please open an image.");
else { //



doc.Merge();
var docSize = VBArray(doc.Size).toArray();
docSize[2] = Math.sqrt(docSize[0] * docSize[1]); // geometric mean of the dimensions
var docPath = doc.Path;

var ww, hh, x0, x1, x2, x3, y0, y1, y2, y3;



// settings:
var printEdge = Math.ceil(docSize[2]/1000);
var matSpace = Math.ceil(docSize[2]/22);
var matPly = Math.ceil(docSize[2]/100);
var ratio = 1.7;  // mount size as a ratio of the linear dimensions of the mount to the print
var title = pl.InputBox("PhotoLine", "title:");
var fontName = "MinionPro-Regular";
var fontSize = docSize[2] * 0.08;



var printSize = docSize;
var surroundWidth = Math.round(docSize[2] * ((ratio - 1) / 2));
var mountWidth = docSize[0] + surroundWidth*2;
var mountHeight = docSize[1] + surroundWidth*2;
  // extra space at the bottom; use 0.1 if not adding a title:
if (title.replace(/\s/g, "") == "")
  mountHeight = Math.round(mountHeight + (surroundWidth - matPly - matSpace - printEdge)*0.1);
else
  mountHeight = Math.round(mountHeight + (surroundWidth - matPly - matSpace - printEdge)*0.2);

var matColor = grayColor(230);
var topColorP = grayColor(240);
var sideColorP = grayColor(200);
var bottomColorP = grayColor(160);
var topColorM = grayColor(120);
var sideColorM = grayColor(160);
var bottomColorM = grayColor(200);
var mountColor = grayColor(255);
var fontColor = grayColor(50);

doc.Merge();
var bg = doc.RootLayer.First;
bg.Copy();
doc.Paste();
bg.Name = "Mount";
bg.Next.Name = "Image";
drawPolygon([0, 0, docSize[0], docSize[1]], mountColor, true, true);



  // PRINT EDGE

ww = docSize[0] + printEdge*2;
hh = docSize[1] + printEdge*2;
doc.DoOperation("Resize", "Size", [ww, hh], "Horizontal", ResizeHorizontalCentered,
  "Vertical", ResizeVerticalCentered, "Color", sideColorP);
docSize = VBArray(doc.Size).toArray();

x0 = 0;
x1 = docSize[0];
x2 = docSize[0] - printEdge;
x3 = printEdge;

y0 = 0;
y1 = 0;
y2 = printEdge;
y3 = printEdge;

drawPolygon([x0,y0, x1,y1, x2,y2, x3,y3], topColorP, true, true);

x0 = printEdge
x1 = docSize[0] - printEdge
x2 = docSize[0]
x3 = 0

y0 = docSize[1] - printEdge
y1 = docSize[1] - printEdge
y2 = docSize[1]
y3 = docSize[1]

drawPolygon([x0,y0, x1,y1, x2,y2, x3,y3], bottomColorP, true, true);


  // MAT SPACE

ww = docSize[0] + matSpace*2;
hh = docSize[1] + matSpace*2;
doc.DoOperation("Resize", "Size", [ww, hh], "Horizontal", ResizeHorizontalCentered,
  "Vertical", ResizeVerticalCentered, "Color", mountColor);
docSize = VBArray(doc.Size).toArray();



  // MAT BEVEL

ww = docSize[0] + matPly*2;
hh = docSize[1] + matPly*2;
doc.DoOperation("Resize", "Size", [ww, hh], "Horizontal", ResizeHorizontalCentered,
  "Vertical", ResizeVerticalCentered, "Color", sideColorM);
docSize = VBArray(doc.Size).toArray();

x0 = 0;
x1 = docSize[0];
x2 = docSize[0] - matPly;
x3 = matPly;

y0 = 0;
y1 = 0;
y2 = matPly;
y3 = matPly;

drawPolygon([x0,y0, x1,y1, x2,y2, x3,y3], topColorM, true, true);

x0 = matPly;
x1 = docSize[0] - matPly;
x2 = docSize[0];
x3 = 0;

y0 = docSize[1] - matPly;
y1 = docSize[1] - matPly;
y2 = docSize[1];
y3 = docSize[1];

drawPolygon([x0,y0, x1,y1, x2,y2, x3,y3], bottomColorM, true, true);



  // MOUNT SIZE

ww = mountWidth;
hh = mountHeight;
left = (mountWidth - docSize[0]) / 2;
top = surroundWidth - matPly - matSpace - printEdge;
doc.DoOperation("Resize", "Size", [ww, hh], "Position", [left, top], "Color", matColor);
docSize = VBArray(doc.Size).toArray();



  // TITLE

if (title.replace(/\s/g, "") != "") {

  var left = 0;
  var top = surroundWidth + printSize[1] + matPly + matSpace + printEdge + fontSize*1.25;
  ww = docSize[0];
  hh = fontSize;

  var textLayer = createTextLayer(title, fontName, fontSize, fontColor, left, top, ww, hh, PACenter, true);

  doc.ActiveLayer = textLayer;
  textLayer.Name = "Title";
  layerToRGB(8);
  emboss(135, 12, Math.round(fontSize/30), 16, CSReversedLowered, 0);

}



doc.ActiveLayer = doc.RootLayer;



} //
